int BST[14] ={
// BST  Non-BST start in Mar 2015 Oct 2019
     29,  25,
     27,  30,
     26,  29,
     25,  28,
     31,  27,
  };


void print_time()
{
  RTC.get(rtc,true);
  int local_hour;
  check_BST();
  lcd.setCursor(0,1);
  if(BST_flag==false) local_hour=rtc[2];
  else {
  if (rtc[2]+1==24)
 local_hour=0;
  else local_hour=rtc[2]+1;
}

  if(local_hour < 10)
    lcd.print('0');
  lcd.print(local_hour); 
  if (Flash == 0) 
  {      
    lcd.print(":");
    Flash = 1;
  } 
  else {
    lcd.print(" ");
    Flash = 0;
  }
  if(rtc[1] < 10)
    lcd.print('0');  
  lcd.print(rtc[1]);

  int month=rtc[5]-1;
  BedTime=((sun_set[(month*2)])*60)+sun_set[(month*2)+1];
  WakeTime=((sun_rise[(month*2)])*60)+sun_rise[(month*2)+1];
  GlobTime=(local_hour*60)+rtc[1];
}



void set_time_date()
{
  lcd.clear();
  lcd.print("GMT   Date  Year");
  lcd.setCursor(0,1);
  RTC.get(rtc,true);
  RTC.stop();

  lcd.print(rtc[2]);
  if(rtc[2] < 10)
    lcd.print('0');  
  lcd.print(":");
  if(rtc[1] < 10)
    lcd.print('0');  
  lcd.print(rtc[1]);

  int user_input=rtc[2]; // Set input for RTC HR
  phi_prompt_struct myIntegerInput;
  myIntegerInput.ptr.i_buffer=&user_input;
  myIntegerInput.low.i=0;
  myIntegerInput.high.i=23;
  myIntegerInput.step.i=1;
  myIntegerInput.col=0;
  myIntegerInput.row=1;
  myIntegerInput.width=2;
  myIntegerInput.option=1;
  input_integer(&myIntegerInput);
  RTC.set(DS1307_HR,user_input);

  user_input=rtc[1]; // Set input to be RTC MIN

  myIntegerInput.low.i=0;
  myIntegerInput.high.i=59;
  myIntegerInput.col=3;
  input_integer(&myIntegerInput); 
  RTC.set(DS1307_MIN,user_input);

  lcd.setCursor(6,1);
  if(rtc[4] < 10)
    lcd.print('0');  
  lcd.print(rtc[4]);
  lcd.print("/");
  if(rtc[5] < 10)
    lcd.print('0');  
  lcd.print(rtc[5]);

  user_input=rtc[4]; // Set input for RTC DATE
  myIntegerInput.low.i=1;
  myIntegerInput.high.i=31;
  myIntegerInput.col=6;
  input_integer(&myIntegerInput);
  RTC.set(DS1307_DATE,user_input);

  user_input=rtc[5]; // Set input to be RTC MTH
  myIntegerInput.high.i=12;
  myIntegerInput.col=9;
  input_integer(&myIntegerInput); 
  RTC.set(DS1307_MTH,user_input);

  user_input=rtc[6]; // Set input to be RTC YR
  lcd.setCursor(12,1);
  lcd.print(user_input);
  user_input=user_input-2000;
  myIntegerInput.low.i=0;
  myIntegerInput.high.i=99;
  myIntegerInput.col=14;
  input_integer(&myIntegerInput); 
  RTC.set(DS1307_YR,user_input);

  RTC.start();
  wait_on_escape(2000);

}




void check_BST()
{
  int BST_start_day = BST[(rtc[6]-2013)*2];
  int BST_finish_day = BST[((rtc[6]-2013)*2)+1];
  lcd.setCursor(0,0);
  int BST_start_date=(300+BST_start_day);
  int BST_finish_date=(1000+BST_finish_day);
  int Today=((rtc[5]*100)+rtc[4]);         //crude convert date to number for comparison

  if ((Today>= BST_start_date && Today <= BST_finish_date))
  {
    lcd.print("BST ");
    BST_flag=true;
  }
  else
  {
    lcd.print("GMT ");
    BST_flag=false;
  }
}













